/*
****************************************
**  Copyright  (C)  W.ch  1999-2015   **
**  Web:              http://wch.cn   **
****************************************
*/
/* USB host example for CH559, CH559ɨǹֱַԴ*/

/* C51   TEST.C */
/* LX51  TEST.OBJ */
/* OHX51 TEST */

#include <CH559.H>
#include <stdio.h>
#include <string.h>

// ӳ򷵻״̬
#define	ERR_SUCCESS			0x00	// ɹ
#define	ERR_USB_CONNECT		0x15	/* ⵽USB豸¼,Ѿ */
#define	ERR_USB_DISCON		0x16	/* ⵽USB豸Ͽ¼,ѾϿ */
#define	ERR_USB_BUF_OVER	0x17	/* USB̫໺ */
#define	ERR_USB_DISK_ERR	0x1F	/* USB洢ʧ,ڳʼʱUSB洢֧,ڶдпǴ𻵻ѾϿ */
#define	ERR_USB_TRANSFER	0x20	/* NAK/STALLȸ0x20~0x2F */
#define	ERR_USB_UNSUPPORT	0xFB
#define	ERR_USB_UNKNOWN		0xFE

// ȡ豸
UINT8C	SetupGetDevDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_DEVICE, 0x00, 0x00, sizeof( USB_DEV_DESCR ), 0x00 };
// ȡ
UINT8C	SetupGetCfgDescr[] = { USB_REQ_TYP_IN, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_CONFIG, 0x00, 0x00, 0x04, 0x00 };
// USBַ
UINT8C	SetupSetUsbAddr[] = { USB_REQ_TYP_OUT, USB_SET_ADDRESS, USB_DEVICE_ADDR, 0x00, 0x00, 0x00, 0x00, 0x00 };
// USB
UINT8C	SetupSetUsbConfig[] = { USB_REQ_TYP_OUT, USB_SET_CONFIGURATION, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
// ˵STALL
UINT8C	SetupClrEndpStall[] = { USB_REQ_TYP_OUT | USB_REQ_RECIP_ENDP, USB_CLEAR_FEATURE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
// ȡHUB
UINT8C	SetupGetHubDescr[] = { HUB_GET_HUB_DESCRIPTOR, HUB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_HUB, 0x00, 0x00, sizeof( USB_HUB_DESCR ), 0x00 };
// ȡHID豸
UINT8C	SetupGetHIDDevReport[] = { 0x81, USB_GET_DESCRIPTOR, 0x00, USB_DESCR_TYP_REPORT, 0x00, 0x00, 0x49, 0x00 };
// SET_Report
UINT8C	SetupSetKeyReport[] = { 0x21, 0x09, 0x00, 0x02, 0x00, 0x00, 0x01, 0x00 };

UINT8X	UsbDevEndp0Size;	/* USB豸Ķ˵0ߴ */

//USB豸Ϣ,CH559֧2豸
#define	ROOT_DEV_DISCONNECT		0
#define	ROOT_DEV_CONNECTED		1
#define	ROOT_DEV_FAILED			2
#define	ROOT_DEV_SUCCESS		3

#define	DEV_TYPE_KEYBOARD	( USB_DEV_CLASS_HID | 0x20 )
#define	DEV_TYPE_MOUSE		( USB_DEV_CLASS_HID | 0x30 )

UINT8 Set_Port = 0;
struct _RootHubDev{
	UINT8	DeviceStatus;			// 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
	UINT8	DeviceAddress;		// 豸USBַ
	UINT8	DeviceSpeed;			// 0Ϊ,0Ϊȫ
	UINT8	DeviceType;				// 豸
//	union {
//		struct MOUSE {
//			UINT8	MouseInterruptEndp;		// ж϶˵
//			UINT8	MouseIntEndpTog;		// ж϶˵ͬ־
//			UINT8	MouseIntEndpSize;		// ж϶˵ĳ
//		}
//		struct PRINT {
//		}
//	}
//.....    struct  _Endp_Attr   Endp_Attr[4];	//˵,֧4˵
	UINT8	GpVar;					// ͨñ
	UINT8	GpVar1;					// ͨñ1
} xdata RootHubDev[2];

#define	HUB_MAX_PORTS	4

/*
Լ: USB豸ַ(οUSB_DEVICE_ADDR)
ֵַ  豸λ
0x02    Root-HUB0µUSB豸ⲿHUB
0x03    Root-HUB1µUSB豸ⲿHUB
0x1x    Root-HUB0µⲿHUBĶ˿xµUSB豸,xΪ1~n
0x2x    Root-HUB1µⲿHUBĶ˿xµUSB豸,xΪ1~n
*/

struct _DevOnHubPort{
	UINT8	DeviceStatus;			// 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
	UINT8	DeviceAddress;			// 豸USBַ
	UINT8	DeviceSpeed;			// 0Ϊ,0Ϊȫ
	UINT8	DeviceType;				// 豸
//.....    struct  _Endp_Attr   Endp_Attr[4];	//˵,֧4˵
	UINT8	GpVar;					// ͨñ
} xdata DevOnHubPort[2][HUB_MAX_PORTS];  // ٶ:2ⲿHUB,ÿⲿHUBHUB_MAX_PORTS˿(˲)

UINT8X	RxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0000 ;  // IN, must even address
UINT8X	TxBuffer[ MAX_PACKET_SIZE ] _at_ 0x0100 ;  // OUT, must even address
#define	pSetupReq	((PXUSB_SETUP_REQ)TxBuffer)
bit		RootHubId;		// ǰڲroot-hub˿ں:0=HUB0,1=HUB1
bit		FoundNewDev;

//sbit LED_RUN  = P1^0;
//sbit LED_CFG  = P1^1;
//sbit LED_TMP  = P1^2;

#pragma NOAREGS

void	mDelayuS( UINT16 n );  // uSΪλʱ

void	mDelaymS( UINT16 n );  // mSΪλʱ

void	DisableRootHubPort( UINT8 RootHubIndex );  // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬

UINT8	AnalyzeRootHub( void );   // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ

void	SetHostUsbAddr( UINT8 addr );  // USBǰUSB豸ַ

void	SetUsbSpeed( UINT8 FullSpeed );  // õǰUSBٶ

void	ResetRootHubPort( UINT8 RootHubIndex );  // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ

UINT8	EnableRootHubPort( UINT8 RootHubIndex );  // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ

void	SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex );  // HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿

#define	WAIT_USB_TOUT_200US		200  // ȴUSBжϳʱʱ200uS@Fsys=12MHz
UINT8	WaitUSB_Interrupt( void );  // ȴUSBж

// CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8	USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout );  // endp_pid: 4λtoken_pid, 4λǶ˵ַ

UINT8	HostCtrlTransfer( PUINT8X DataBuf, PUINT8I RetLen );  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȷرReqLenָֽڱ

void	CopySetupReqPkg( PUINT8C pReqPkt );  // ƿƴ

UINT8	CtrlGetDeviceDescr( void );  // ȡ豸,TxBuffer

UINT8	CtrlGetConfigDescr( void );  // ȡ,TxBuffer

UINT8	CtrlSetUsbAddress( UINT8 addr );  // USB豸ַ

UINT8	CtrlSetUsbConfig( UINT8 cfg );  // USB豸

UINT8	CtrlClearEndpStall( UINT8 endp );  // ˵STALL

UINT8	CtrlGetHubDescr( void );  // ȡHUB,TxBuffer

UINT8	HubGetPortStatus( UINT8 HubPortIndex );  // ѯHUB˿״̬,TxBuffer

UINT8	HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿

UINT8	HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt );  // HUB˿

UINT8	AnalyzeHidIntEndp( PUINT8X buf );  // зHIDж϶˵ĵַ

UINT8	InitRootDevice( UINT8 RootHubIndex );  // ʼָROOT-HUB˿ڵUSB豸
// : HUB˿ں0/1

UINT8	EnumAllRootDevice( void );  // öROOT-HUB˿ڵUSB豸

UINT8	InitDevOnHub( UINT8 RootHubIndex, UINT8 HubPortIndex );  // ʼöⲿHUBĶUSB豸

UINT8	EnumHubPort( UINT8 RootHubIndex );  // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸

UINT8	EnumAllHubPort( void );  // öROOT-HUB˿ⲿHUBĶUSB豸

UINT16	SearchTypeDevice( UINT8 type );  // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
// 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( void );

void	InitUSB_Host( void );  // ʼUSB

#define	FREQ_SYS	24000000	// ϵͳƵ20MHz

void	mDelayuS( UINT16 n )  // uSΪλʱ
{
	while ( n ) {  // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
		++ SAFE_MOD;  // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef	FREQ_SYS
#if		FREQ_SYS >= 14000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 16000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 18000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 20000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 22000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 24000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 26000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 28000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 30000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 32000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 34000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 36000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 38000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 40000000
		++ SAFE_MOD;
#endif
#endif
		-- n;
	}
}

void	mDelaymS( UINT16 n )  // mSΪλʱ
{
	while ( n ) {
		mDelayuS( 1000 );
		-- n;
	}
}

void	DisableRootHubPort( UINT8 RootHubIndex )  // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
	RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_DISCONNECT;
	RootHubDev[ RootHubIndex ].DeviceAddress = 0x00;
	if ( RootHubIndex == 1 ) UHUB1_CTRL = 0x00;  // йHUB1Ŀ,ʵϲҪ
	else UHUB0_CTRL = 0x00;  // йHUB0Ŀ,ʵϲҪ
//	printf( "HUB %01x close\n",(UINT16)RootHubIndex );
}

UINT8	AnalyzeRootHub( void )   // ROOT-HUB״̬,ROOT-HUB˿ڵ豸¼
// ERR_SUCCESSΪû,ERR_USB_CONNECTΪ⵽,ERR_USB_DISCONΪ⵽Ͽ
{ //HUB˿ڵĲ¼,豸γ,еDisableRootHubPort(),˿ڹر,¼,Ӧ˿ڵ״̬λ
	UINT8	s;
	s = ERR_SUCCESS;
	if ( USB_HUB_ST & bUHS_H0_ATTACH ) {  // 豸
		if ( RootHubDev[0].DeviceStatus == ROOT_DEV_DISCONNECT  // ⵽豸
			|| ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 ) {  // ⵽豸,δ,˵Ǹղ
			DisableRootHubPort( 0 );  // رն˿
//			RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
			RootHubDev[0].DeviceStatus = ROOT_DEV_CONNECTED;  //ӱ־
			printf( "HUB 0 dev in\n" );
			s = ERR_USB_CONNECT;
		}
	}
	else if ( RootHubDev[0].DeviceStatus >= ROOT_DEV_CONNECTED ) {  //⵽豸γ
		DisableRootHubPort( 0 );  // رն˿
		printf( "HUB 0 dev out\n" );
		if ( s == ERR_SUCCESS ) s = ERR_USB_DISCON;
	}
	if ( USB_HUB_ST & bUHS_H1_ATTACH ) {  // 豸
		if ( RootHubDev[1].DeviceStatus == ROOT_DEV_DISCONNECT  // ⵽豸
			|| ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 ) {  // ⵽豸,δ,˵Ǹղ
			DisableRootHubPort( 1 );  // رն˿
//			RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
			RootHubDev[1].DeviceStatus = ROOT_DEV_CONNECTED;  //ӱ־
			printf( "HUB 1 dev in\n" );
			s = ERR_USB_CONNECT;
		}
	}
	else if ( RootHubDev[1].DeviceStatus >= ROOT_DEV_CONNECTED ) {  //⵽豸γ
		DisableRootHubPort( 1 );  // رն˿
		printf( "HUB 1 dev out\n" );
		if ( s == ERR_SUCCESS ) s = ERR_USB_DISCON;
	}
//	UIF_DETECT = 0;  // жϱ־
	return( s );
}

void	SetHostUsbAddr( UINT8 addr )  // USBǰUSB豸ַ
{
	USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | addr & 0x7F;
}

void	SetUsbSpeed( UINT8 FullSpeed )  // õǰUSBٶ
{
	if ( FullSpeed ) {  // ȫ
		USB_CTRL &= ~ bUC_LOW_SPEED;  // ȫ
		UH_SETUP &= ~ bUH_PRE_PID_EN;  // ֹPRE PID
	}
	else {
		USB_CTRL |= bUC_LOW_SPEED;  // 
	}
}

void	ResetRootHubPort( UINT8 RootHubIndex )  // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
{
	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;  /* USB豸Ķ˵0ߴ */
	SetHostUsbAddr( 0x00 );
	SetUsbSpeed( 1 );  // ĬΪȫ
	if ( RootHubIndex == 1 ) {
		UHUB1_CTRL = UHUB1_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;  // ĬΪȫ,ʼλ
		mDelaymS( 15 );  // λʱ10mS20mS
		UHUB1_CTRL = UHUB1_CTRL & ~ bUH_BUS_RESET;  // λ
	}
	else {
		UHUB0_CTRL = UHUB0_CTRL & ~ bUH_LOW_SPEED | bUH_BUS_RESET;  // ĬΪȫ,ʼλ
		mDelaymS( 15 );  // λʱ10mS20mS
		UHUB0_CTRL = UHUB0_CTRL & ~ bUH_BUS_RESET;  // λ
	}
	mDelayuS( 250 );
	UIF_DETECT = 0;  // жϱ־
}

UINT8	EnableRootHubPort( UINT8 RootHubIndex )  // ʹROOT-HUB˿,ӦbUH_PORT_EN1˿,豸Ͽܵ·ʧ
{
	if ( RootHubDev[ RootHubIndex ].DeviceStatus < ROOT_DEV_CONNECTED ) RootHubDev[ RootHubIndex ].DeviceStatus = ROOT_DEV_CONNECTED;
	if ( RootHubIndex == 1 ) {
		if ( USB_HUB_ST & bUHS_H1_ATTACH ) {  // 豸
			if ( ( UHUB1_CTRL & bUH_PORT_EN ) == 0x00 ) {  // δʹ
				RootHubDev[1].DeviceSpeed = USB_HUB_ST & bUHS_HM_LEVEL ? 0 : 1;
				if ( RootHubDev[1].DeviceSpeed == 0 ) UHUB1_CTRL |= bUH_LOW_SPEED;  // 
			}
			UHUB1_CTRL |= bUH_PORT_EN;  //ʹHUB˿
			return( ERR_SUCCESS );
		}
	}
	else {
		if ( USB_HUB_ST & bUHS_H0_ATTACH ) {  // 豸
			if ( ( UHUB0_CTRL & bUH_PORT_EN ) == 0x00 ) {  // δʹ
				RootHubDev[0].DeviceSpeed = USB_HUB_ST & bUHS_DM_LEVEL ? 0 : 1;
				if ( RootHubDev[0].DeviceSpeed == 0 ) UHUB0_CTRL |= bUH_LOW_SPEED;  // 
			}
			UHUB0_CTRL |= bUH_PORT_EN;  //ʹHUB˿
			return( ERR_SUCCESS );
		}
	}
	return( ERR_USB_DISCON );
}

void	SelectHubPort( UINT8 RootHubIndex, UINT8 HubPortIndex )  // HubPortIndex=0ѡָROOT-HUB˿,ѡָROOT-HUB˿ڵⲿHUBָ˿
{
	if ( HubPortIndex ) {  // ѡָROOT-HUB˿ڵⲿHUBָ˿
		SetHostUsbAddr( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceAddress );  // USBǰUSB豸ַ
		if ( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceSpeed == 0 ) {  // ͨⲿHUBUSB豸ͨѶҪǰID
			UH_SETUP |= bUH_PRE_PID_EN;  // PRE PID
		}
		SetUsbSpeed( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceSpeed );  // õǰUSBٶ
	}
	else {  // ѡָROOT-HUB˿
		SetHostUsbAddr( RootHubDev[RootHubIndex].DeviceAddress );  // USBǰUSB豸ַ
		SetUsbSpeed( RootHubDev[RootHubIndex].DeviceSpeed );  // õǰUSBٶ
	}
	RootHubId = RootHubIndex ? 1 : 0;
}

UINT8	WaitUSB_Interrupt( void )  // ȴUSBж
{
	UINT16	i;
	for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- );
	return( UIF_TRANSFER ? ERR_SUCCESS : ERR_USB_UNKNOWN );
}

// CH559,ĿĶ˵ַ/PID,ͬ־,20uSΪλNAKʱ(0,0xFFFF),0ɹ,ʱ/
UINT8	USBHostTransact( UINT8 endp_pid, UINT8 tog, UINT16 timeout )  // endp_pid: 4λtoken_pid, 4λǶ˵ַ
{  // ӳ,ʵӦ,Ϊṩٶ,ӦöԱӳŻ
//	UINT8	TransRetry;
#define	TransRetry	UEP0_T_LEN	// Լڴ
	UINT8	s, r;
	UINT16	i;
	UH_RX_CTRL = UH_TX_CTRL = tog;
	TransRetry = 0;
	do {
//		LED_TMP = 0;
		UH_EP_PID = endp_pid;  // ָPIDĿĶ˵
		UIF_TRANSFER = 0;  // 
//		s = WaitUSB_Interrupt( );
		for ( i = WAIT_USB_TOUT_200US; i != 0 && UIF_TRANSFER == 0; i -- );
		UH_EP_PID = 0x00;  // ֹͣUSB
//		LED_TMP = 1;
//		if ( s != ERR_SUCCESS ) return( s );  // жϳʱ,Ӳ쳣
		if ( UIF_TRANSFER == 0 ) return( ERR_USB_UNKNOWN );
		if ( UIF_DETECT ) {  // USB豸¼
//			mDelayuS( 200 );  // ȴ
			UIF_DETECT = 0;  // жϱ־
			s = AnalyzeRootHub( );   // ROOT-HUB״̬
			if ( s == ERR_USB_CONNECT ) FoundNewDev = 1;
			if ( RootHubDev[RootHubId].DeviceStatus == ROOT_DEV_DISCONNECT ) return( ERR_USB_DISCON );  // USB豸Ͽ¼
			if ( RootHubDev[RootHubId].DeviceStatus == ROOT_DEV_CONNECTED ) return( ERR_USB_CONNECT );  // USB豸¼
//			if ( ( USB_HUB_ST & bUHS_H0_ATTACH ) == 0x00 ) return( ERR_USB_DISCON );  // USB豸Ͽ¼
			mDelayuS( 200 );  // ȴ
		}
		if ( UIF_TRANSFER ) {  // 
			if ( U_TOG_OK ) return( ERR_SUCCESS );
#ifdef DEBUG_NOW
printf("endp_pid=%02X\n",(UINT16)endp_pid);
printf("USB_INT_FG=%02X\n",(UINT16)USB_INT_FG);
printf("USB_INT_ST=%02X\n",(UINT16)USB_INT_ST);
printf("USB_MIS_ST=%02X\n",(UINT16)USB_MIS_ST);
printf("USB_RX_LEN=%02X\n",(UINT16)USB_RX_LEN);
printf("UH_TX_LEN=%02X\n",(UINT16)UH_TX_LEN);
printf("UH_RX_CTRL=%02X\n",(UINT16)UH_RX_CTRL);
printf("UH_TX_CTRL=%02X\n",(UINT16)UH_TX_CTRL);
printf("UHUB0_CTRL=%02X\n",(UINT16)UHUB0_CTRL);
printf("UHUB1_CTRL=%02X\n",(UINT16)UHUB1_CTRL);
#endif
			r = USB_INT_ST & MASK_UIS_H_RES;  // USB豸Ӧ״̬
			if ( r == USB_PID_STALL ) return( r | ERR_USB_TRANSFER );
			if ( r == USB_PID_NAK ) {
				if ( timeout == 0 ) return( r | ERR_USB_TRANSFER );
				if ( timeout < 0xFFFF ) timeout --;
				-- TransRetry;
			}
			else switch ( endp_pid >> 4 ) {
				case USB_PID_SETUP:
				case USB_PID_OUT:
//					if ( U_TOG_OK ) return( ERR_SUCCESS );
//					if ( r == USB_PID_ACK ) return( ERR_SUCCESS );
//					if ( r == USB_PID_STALL || r == USB_PID_NAK ) return( r | ERR_USB_TRANSFER );
					if ( r ) return( r | ERR_USB_TRANSFER );  // ǳʱ/,Ӧ
					break;  // ʱ
				case USB_PID_IN:
//					if ( U_TOG_OK ) return( ERR_SUCCESS );
//					if ( tog ? r == USB_PID_DATA1 : r == USB_PID_DATA0 ) return( ERR_SUCCESS );
//					if ( r == USB_PID_STALL || r == USB_PID_NAK ) return( r | ERR_USB_TRANSFER );
					if ( r == USB_PID_DATA0 && r == USB_PID_DATA1 ) {  // ͬ趪
					}  // ͬ
					else if ( r ) return( r | ERR_USB_TRANSFER );  // ǳʱ/,Ӧ
					break;  // ʱ
				default:
					return( ERR_USB_UNKNOWN );  // ܵ
					break;
			}
		}
		else {  // ж,Ӧ÷
			USB_INT_FG = 0xFF;  /* жϱ־ */
		}
		mDelayuS( 15 );
	} while ( ++ TransRetry < 3 );
	return( ERR_USB_TRANSFER );  // Ӧʱ
}

UINT8	HostCtrlTransfer( PUINT8X DataBuf, PUINT8 RetLen )  // ִпƴ,8ֽpSetupReq,DataBufΪѡշ
// Ҫպͷ,ôDataBufָЧڴź,ʵʳɹշܳȱReqLenָֽڱ
{
	UINT8	s, RemLen, RxLen, RxCnt, TxCnt;
	PUINT8X	xdata	pBuf;
	PUINT8	xdata	pLen;
	pBuf = DataBuf;
	pLen = RetLen;
	mDelayuS( 200 );
	if ( pLen ) *pLen = 0;  // ʵʳɹշܳ
	UH_TX_LEN = sizeof( USB_SETUP_REQ );
	s = USBHostTransact( USB_PID_SETUP << 4 | 0x00, 0x00, 200000/20 );  // SETUP׶,200mSʱ
	if ( s != ERR_SUCCESS ) return( s );
	UH_RX_CTRL = UH_TX_CTRL = bUH_R_TOG | bUH_R_AUTO_TOG | bUH_T_TOG | bUH_T_AUTO_TOG;  // ĬDATA1
	UH_TX_LEN = 0x01;  // Ĭݹ״̬׶ΪIN
	RemLen = pSetupReq -> wLengthH ? 0xFF : pSetupReq -> wLengthL;
	if ( RemLen && pBuf ) {  // Ҫշ
		if ( pSetupReq -> bRequestType & USB_REQ_TYP_IN ) {  // 
			while ( RemLen ) {
				mDelayuS( 200 );
				s = USBHostTransact( USB_PID_IN << 4 | 0x00, UH_RX_CTRL, 200000/20 );  // IN
				if ( s != ERR_SUCCESS ) return( s );
				RxLen = USB_RX_LEN < RemLen ? USB_RX_LEN : RemLen;
				RemLen -= RxLen;
				if ( pLen ) *pLen += RxLen;  // ʵʳɹշܳ
//				memcpy( pBuf, RxBuffer, RxLen );
//				pBuf += RxLen;
				for ( RxCnt = 0; RxCnt != RxLen; RxCnt ++ ) {
					*pBuf = RxBuffer[ RxCnt ];
					pBuf ++;
				}
				if ( USB_RX_LEN == 0 || ( USB_RX_LEN & ( UsbDevEndp0Size - 1 ) ) ) break;  // ̰
			}
			UH_TX_LEN = 0x00;  // ״̬׶ΪOUT
		}
		else {  // 
			while ( RemLen ) {
				mDelayuS( 200 );
				UH_TX_LEN = RemLen >= UsbDevEndp0Size ? UsbDevEndp0Size : RemLen;
//				memcpy( TxBuffer, pBuf, UH_TX_LEN );
//				pBuf += UH_TX_LEN;
				if(pBuf[1] == 0x09)//
        {
            Set_Port = Set_Port^1 ? 1:0;
					  *pBuf = Set_Port;
				    printf("SET_PORT  %02X  %02X ",(UINT16)(*pBuf),(UINT16)(Set_Port));
        }
				for ( TxCnt = 0; TxCnt != UH_TX_LEN; TxCnt ++ ) {
					 TxBuffer[ TxCnt ] = *pBuf;
					 pBuf ++;
				}
				s = USBHostTransact( USB_PID_OUT << 4 | 0x00, UH_TX_CTRL, 200000/20 );  // OUT
				if ( s != ERR_SUCCESS ) return( s );
				RemLen -= UH_TX_LEN;
				if ( pLen ) *pLen += UH_TX_LEN;  // ʵʳɹշܳ
			}
//			UH_TX_LEN = 0x01;  // ״̬׶ΪIN
		}
	}
	mDelayuS( 200 );
	s = USBHostTransact( ( UH_TX_LEN ? USB_PID_IN << 4 | 0x00: USB_PID_OUT << 4 | 0x00 ), bUH_R_TOG | bUH_T_TOG, 200000/20 );  // STATUS׶
	if ( s != ERR_SUCCESS ) return( s );
	if ( UH_TX_LEN == 0 ) return( ERR_SUCCESS );  // ״̬OUT
	if ( USB_RX_LEN == 0 ) return( ERR_SUCCESS );  // ״̬IN,IN״̬ݳ
	return( ERR_USB_BUF_OVER );  // IN״̬׶δ
}

void	CopySetupReqPkg( PUINT8C pReqPkt )  // ƿƴ
{
	UINT8	i;
	for ( i = 0; i != sizeof( USB_SETUP_REQ ); i ++ ) {
		((PUINT8X)pSetupReq)[ i ] = *pReqPkt;
		pReqPkt ++;
	}
}

UINT8	CtrlGetDeviceDescr( void )  // ȡ豸,TxBuffer
{
	UINT8	s;
	UINT8	len;
	UsbDevEndp0Size = DEFAULT_ENDP0_SIZE;
	CopySetupReqPkg( SetupGetDevDescr );
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	UsbDevEndp0Size = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bMaxPacketSize0;  // ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndp0Sizeټ
	if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL ) return( ERR_USB_BUF_OVER );  // ȴ
	return( ERR_SUCCESS );
}

UINT8	CtrlGetConfigDescr( void )  // ȡ,TxBuffer
{
	UINT8	s;
	UINT8D	len;
	CopySetupReqPkg( SetupGetCfgDescr );
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL ) return( ERR_USB_BUF_OVER );  // سȴ
	len = ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL;
	if ( len > MAX_PACKET_SIZE ) return( ERR_USB_BUF_OVER );  // سȴ
	CopySetupReqPkg( SetupGetCfgDescr );
	pSetupReq -> wLengthL = len;  // ܳ
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL || len < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL ) return( ERR_USB_BUF_OVER );  // ȴ
	return( ERR_SUCCESS );
}

UINT8	CtrlSetUsbAddress( UINT8 addr )  // USB豸ַ
{
	UINT8	s;
	CopySetupReqPkg( SetupSetUsbAddr );
	pSetupReq -> wValueL = addr;  // USB豸ַ
	s = HostCtrlTransfer( NULL, NULL );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	SetHostUsbAddr( addr );  // USBǰUSB豸ַ
	mDelaymS( 10 );  // ȴUSB豸ɲ
	return( ERR_SUCCESS );
}

UINT8	CtrlSetUsbConfig( UINT8 cfg )  // USB豸
{
	CopySetupReqPkg( SetupSetUsbConfig );
	pSetupReq -> wValueL = cfg;  // USB豸
	return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}

UINT8	CtrlSetUsbRepot( UINT8 cfg )  // USB豸
{
	CopySetupReqPkg( SetupSetKeyReport );
	return( HostCtrlTransfer( &cfg, NULL ) );  // ִпƴ
}

UINT8	CtrlClearEndpStall( UINT8 endp )  // ˵STALL
{
	CopySetupReqPkg( SetupClrEndpStall );  // ˵Ĵ
	pSetupReq -> wIndexL = endp;  // ˵ַ
	return( HostCtrlTransfer( NULL, NULL ) );  /* ִпƴ */
}

UINT8	CtrlGetHIDDeviceReport( void )  // ȡHID豸,TxBuffer
{
	UINT8	s;
	UINT8	len;
  UINT8 tmp[]={0x21,0x0a,0x00,0x00,0x00,0x00,0x00,0x00};
	for ( s = 0; s != sizeof( tmp ); s ++ ) {
		   ((PUINT8X)pSetupReq)[ s ] = tmp[s];
	    }
      s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
// 	if ( s != ERR_SUCCESS ) return( s );
	CopySetupReqPkg( SetupGetHIDDevReport );
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL ) return( ERR_USB_BUF_OVER );  // ȴ
	return( ERR_SUCCESS );
}

UINT8	CtrlGetHubDescr( void )  // ȡHUB,TxBuffer
{
	UINT8	s;
	UINT8D	len;
	CopySetupReqPkg( SetupGetHubDescr );
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < ( (PUSB_SETUP_REQ)SetupGetHubDescr ) -> wLengthL ) return( ERR_USB_BUF_OVER );  // ȴ
// 	if ( len < 4 ) return( ERR_USB_BUF_OVER );  // ȴ
	return( ERR_SUCCESS );
}

UINT8	HubGetPortStatus( UINT8 HubPortIndex )  // ѯHUB˿״̬,TxBuffer
{
	UINT8	s;
	UINT8D	len;
	pSetupReq -> bRequestType = HUB_GET_PORT_STATUS;
	pSetupReq -> bRequest = HUB_GET_STATUS;
	pSetupReq -> wValueL = 0x00;
	pSetupReq -> wValueH = 0x00;
	pSetupReq -> wIndexL = HubPortIndex;
	pSetupReq -> wIndexH = 0x00;
	pSetupReq -> wLengthL = 0x04;
	pSetupReq -> wLengthH = 0x00;
	s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	if ( s != ERR_SUCCESS ) return( s );
	if ( len < 4 ) return( ERR_USB_BUF_OVER );  // ȴ
	return( ERR_SUCCESS );
}

UINT8	HubSetPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )  // HUB˿
{
	pSetupReq -> bRequestType = HUB_SET_PORT_FEATURE;
	pSetupReq -> bRequest = HUB_SET_FEATURE;
	pSetupReq -> wValueL = FeatureSelt;
	pSetupReq -> wValueH = 0x00;
	pSetupReq -> wIndexL = HubPortIndex;
	pSetupReq -> wIndexH = 0x00;
	pSetupReq -> wLengthL = 0x00;
	pSetupReq -> wLengthH = 0x00;
	return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}

UINT8	HubClearPortFeature( UINT8 HubPortIndex, UINT8 FeatureSelt )  // HUB˿
{
	pSetupReq -> bRequestType = HUB_CLEAR_PORT_FEATURE;
	pSetupReq -> bRequest = HUB_CLEAR_FEATURE;
	pSetupReq -> wValueL = FeatureSelt;
	pSetupReq -> wValueH = 0x00;
	pSetupReq -> wIndexL = HubPortIndex;
	pSetupReq -> wIndexH = 0x00;
	pSetupReq -> wLengthL = 0x00;
	pSetupReq -> wLengthH = 0x00;
	return( HostCtrlTransfer( NULL, NULL ) );  // ִпƴ
}

/* ************************************************************************************** */

UINT8	AnalyzeHidIntEndp( PUINT8X buf )  // зHIDж϶˵ĵַ
{
	UINT8	i, s, l;
	s = 0;
	for ( i = 0; i < ( (PXUSB_CFG_DESCR)buf ) -> wTotalLengthL; i += l ) {  // ж϶˵,ͽӿ
		if ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bDescriptorType == USB_DESCR_TYP_ENDP  // Ƕ˵
			&& ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bmAttributes & USB_ENDP_TYPE_MASK ) == USB_ENDP_TYPE_INTER  // ж϶˵
			&& ( ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_DIR_MASK ) ) {  // IN˵
				s = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bEndpointAddress & USB_ENDP_ADDR_MASK;  // ж϶˵ĵַ
				break;  // ԸҪwMaxPacketSizebInterval
		}
		l = ( (PXUSB_ENDP_DESCR)(buf+i) ) -> bLength;  // ǰ,
		if ( l > 16 ) break;
	}
	return( s );
}

UINT8	InitRootDevice( UINT8 RootHubIndex )  // ʼָROOT-HUB˿ڵUSB豸
// : HUB˿ں0/1
{
	UINT8	i, s, cfg, dv_cls, if_cls;
	printf( "Reset root hub %1d# port\n", (UINT16)RootHubIndex );
	ResetRootHubPort( RootHubIndex );  // ⵽豸,λӦ˿ڵUSB
	for ( i = 0, s = 0; i < 100; i ++ ) {  // ȴUSB豸λ,100mSʱ
		mDelaymS( 1 );
		if ( EnableRootHubPort( RootHubIndex ) == ERR_SUCCESS ) {  // ʹROOT-HUB˿
			i = 0;
			s ++;  // ʱȴUSB豸Ӻȶ
			if ( s > 100 ) break;  // Ѿȶ100mS
		}
	}
	if ( i ) {  // λ豸û
		DisableRootHubPort( RootHubIndex );
		printf( "Disable root hub %1d# port because of disconnect\n", (UINT16)RootHubIndex );
		return( ERR_USB_DISCON );
	}
	SelectHubPort( RootHubIndex, 0 );
	printf( "GetDevDescr: " );
	s = CtrlGetDeviceDescr( );  // ȡ豸
	if ( s == ERR_SUCCESS ) {
		for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ ) printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
		printf( "\n" ); // ʾ
		dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;  // 豸
		s = CtrlSetUsbAddress( RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );  // USB豸ַ,RootHubIndexԱ֤2HUB˿ڷ䲻ͬĵַ
		if ( s == ERR_SUCCESS ) {
			RootHubDev[RootHubIndex].DeviceAddress = RootHubIndex + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL;  // USBַ
			printf( "GetCfgDescr: " );
			s = CtrlGetConfigDescr( );  // ȡ
			if ( s == ERR_SUCCESS ) {
				cfg = ( (PXUSB_CFG_DESCR)TxBuffer ) -> bConfigurationValue;
				for ( i = 0; i < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL; i ++ ) printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
				printf("\n");
/* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
				if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ
				if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE ) {  // USB洢豸,ȷU
					s = CtrlSetUsbConfig( cfg );  // USB豸
					if ( s == ERR_SUCCESS ) {
						RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
						RootHubDev[RootHubIndex].DeviceType = USB_DEV_CLASS_STORAGE;
						printf( "USB-Disk Ready\n" );
						SetUsbSpeed( 1 );  // ĬΪȫ
						return( ERR_SUCCESS );
					}
				}
				else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_PRINTER && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass == 0x01 ) {  // Ǵӡ豸
					s = CtrlSetUsbConfig( cfg );  // USB豸
					if ( s == ERR_SUCCESS ) {
//						豣˵ϢԱUSB
						RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
						RootHubDev[RootHubIndex].DeviceType = USB_DEV_CLASS_PRINTER;
						printf( "USB-Print Ready\n" );
						SetUsbSpeed( 1 );  // ĬΪȫ
						return( ERR_SUCCESS );
					}
				}
				else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass <= 0x01 ) {  // HID豸,/
					s = AnalyzeHidIntEndp( TxBuffer );  // зHIDж϶˵ĵַ
					RootHubDev[RootHubIndex].GpVar = s & USB_ENDP_ADDR_MASK ;  // ж϶˵ĵַ,λ7ͬ־λ,0
					if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceProtocol;
					s = CtrlSetUsbConfig( cfg );  // USB豸
					if ( s == ERR_SUCCESS ) {
						  printf( "GetHIDReport: " );
              s = CtrlGetHIDDeviceReport();//ȡ
						  if(s == ERR_SUCCESS)
							{
				          for ( i = 0; i < 64; i++ ) printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
				          printf("\n");								
              }
//						Set_Idle( );
//						豣˵ϢԱUSB
						RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
						if ( if_cls == 1 ) {
							RootHubDev[RootHubIndex].DeviceType = DEV_TYPE_KEYBOARD;
//							һʼ,豸ָʾLED
              CtrlSetUsbRepot(1);						
							printf( "USB-Keyboard Ready\n" );
							SetUsbSpeed( 1 );  // ĬΪȫ
							return( ERR_SUCCESS );
						}
						else if ( if_cls == 2 ) {
							RootHubDev[RootHubIndex].DeviceType = DEV_TYPE_MOUSE;
//							ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
							printf( "USB-Mouse Ready\n" );
							SetUsbSpeed( 1 );  // ĬΪȫ
							return( ERR_SUCCESS );
						}
						s = ERR_USB_UNSUPPORT;
					}
				}
				else if ( dv_cls == USB_DEV_CLASS_HUB ) {  // HUB豸,
					s = AnalyzeHidIntEndp( TxBuffer );  // зHIDж϶˵ĵַ
					RootHubDev[RootHubIndex].GpVar1 = s & USB_ENDP_ADDR_MASK ;  // ж϶˵ĵַ,λ7ͬ־λ,0
					printf( "GetHubDescr: ");
					s = CtrlGetHubDescr( );
					if ( s == ERR_SUCCESS ) {
						for( i = 0; i < TxBuffer[0]; i++ ) printf( "x%02X ",(UINT16)(TxBuffer[i]) );
						printf("\n");
						RootHubDev[RootHubIndex].GpVar = ( (PXUSB_HUB_DESCR)TxBuffer ) -> bNbrPorts;  // HUBĶ˿
						if ( RootHubDev[RootHubIndex].GpVar > HUB_MAX_PORTS ) RootHubDev[RootHubIndex].GpVar = HUB_MAX_PORTS;  // ΪṹDevOnHubPortʱΪٶÿHUBHUB_MAX_PORTS˿
//						if ( ( (PXUSB_HUB_DESCR)TxBuffer ) -> wHubCharacteristics[0] & 0x04 ) printf("мĸ豸\n");
//						else printf("һļƷ\n");
						s = CtrlSetUsbConfig( cfg );  // USB豸
						if ( s == ERR_SUCCESS ) {
							RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
							RootHubDev[RootHubIndex].DeviceType = USB_DEV_CLASS_HUB;
//							豣˵ϢԱUSB,ж϶˵HUB¼֪ͨ,ʹòѯ״̬ƴ
//							HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
							for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar; i ++ ) {  // HUB˿ڶϵ
								DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;  // ⲿHUB˿豸״̬
								s = HubSetPortFeature( i, HUB_PORT_POWER );
								if ( s != ERR_SUCCESS ) printf( "Ext-HUB Port_%1d# power on error\n",(UINT16)i );  // ˿ϵʧ
							}
							
							for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar; i ++ ) {  // HUB˿״̬
								s = HubClearPortFeature( i, HUB_C_PORT_CONNECTION );
								if ( s != ERR_SUCCESS ) printf( "Ext-HUB Port_%1d#  clear connection error\n",(UINT16)i );  // ˿״̬ʧ
							}
							SetUsbSpeed( 1 );  // ĬΪȫ
							return( ERR_SUCCESS );
						}
					}
				}
				else {   // Խһ
					s = CtrlSetUsbConfig( cfg );  // USB豸
					if ( s == ERR_SUCCESS ) {
//						豣˵ϢԱUSB
						RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_SUCCESS;
						RootHubDev[RootHubIndex].DeviceStatus = dv_cls ? dv_cls : if_cls;
						SetUsbSpeed( 1 );  // ĬΪȫ
						return( ERR_SUCCESS );  /* δ֪豸ʼɹ */
					}
				}
			}
		}
	}
	printf( "InitRootDev Err = %02X\n", (UINT16)s );
	RootHubDev[RootHubIndex].DeviceStatus = ROOT_DEV_FAILED;
	SetUsbSpeed( 1 );  // ĬΪȫ
	return( s );
}

UINT8	EnumAllRootDevice( void )  // öROOT-HUB˿ڵUSB豸
{
	UINT8	s, RootHubIndex;
	printf( "EnumAllRootDev\n" );
	for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ ) {
		if ( RootHubDev[RootHubIndex].DeviceStatus == ROOT_DEV_CONNECTED ) {   // ղ豸δʼ
			s = InitRootDevice( RootHubIndex );  // ʼ/öָHUB˿ڵUSB豸
			if ( s != ERR_SUCCESS ) return( s );
		}
	}
	return( ERR_SUCCESS );
}

UINT8	InitDevOnHub( UINT8 RootHubIndex, UINT8 HubPortIndex )  // ʼöⲿHUBĶUSB豸
{
	UINT8	i, s, cfg, dv_cls, if_cls;
	printf( "Init dev @ExtHub-port_%1d ", (UINT16)HubPortIndex );
	printf( "@Root_%1d\n", (UINT16)RootHubIndex );
	if ( HubPortIndex == 0 ) return( ERR_USB_UNKNOWN );
	SelectHubPort( RootHubIndex, HubPortIndex );  // ѡָROOT-HUB˿ڵⲿHUBָ˿,ѡٶ
	printf( "GetDevDescr: " );
	s = CtrlGetDeviceDescr( );  // ȡ豸
	if ( s != ERR_SUCCESS ) return( s );
	dv_cls = ( (PXUSB_DEV_DESCR)TxBuffer ) -> bDeviceClass;  // 豸
	cfg = ( (RootHubIndex+1)<<4 ) + HubPortIndex;  // һUSBַ,ַص
	s = CtrlSetUsbAddress( cfg );  // USB豸ַ
	if ( s != ERR_SUCCESS ) return( s );
	DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceAddress = cfg;  // USBַ
	printf( "GetCfgDescr: " );
	s = CtrlGetConfigDescr( );  // ȡ
	if ( s != ERR_SUCCESS ) return( s );
	cfg = ( (PXUSB_CFG_DESCR)TxBuffer ) -> bConfigurationValue;
	for ( i = 0; i < ( (PXUSB_CFG_DESCR)TxBuffer ) -> wTotalLengthL; i ++ ) printf( "x%02X ", (UINT16)( TxBuffer[i] ) );
	printf("\n");
	/* ,ȡ˵/˵ַ/˵С,±endp_addrendp_size */
	if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceClass;  // ӿ
	if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_STORAGE ) {  // USB洢豸,ȷU
		s = CtrlSetUsbConfig( cfg );  // USB豸
		if ( s == ERR_SUCCESS ) {
			DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
			DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = USB_DEV_CLASS_STORAGE;
			printf( "USB-Disk Ready\n" );
			SetUsbSpeed( 1 );  // ĬΪȫ
			return( ERR_SUCCESS );
		}
	}
	else if ( dv_cls == 0x00 && if_cls == USB_DEV_CLASS_HID && ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceSubClass <= 0x01 ) {  // HID豸,/
		s = AnalyzeHidIntEndp( TxBuffer );  // зHIDж϶˵ĵַ
		DevOnHubPort[RootHubIndex][HubPortIndex-1].GpVar = s;  // ж϶˵ĵַ,λ7ͬ־λ,0
		if_cls = ( (PXUSB_CFG_DESCR_LONG)TxBuffer ) -> itf_descr.bInterfaceProtocol;
		s = CtrlSetUsbConfig( cfg );  // USB豸
		if ( s == ERR_SUCCESS ) {
//			豣˵ϢԱUSB
			DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
			if ( if_cls == 1 ) {
				DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = DEV_TYPE_KEYBOARD;
//				һʼ,豸ָʾLED
				printf( "USB-Keyboard Ready\n" );
				SetUsbSpeed( 1 );  // ĬΪȫ
				return( ERR_SUCCESS );
			}
			else if ( if_cls == 2 ) {
				DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = DEV_TYPE_MOUSE;
//				ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
				printf( "USB-Mouse Ready\n" );
				SetUsbSpeed( 1 );  // ĬΪȫ
				return( ERR_SUCCESS );
			}
			s = ERR_USB_UNSUPPORT;
		}
	}
	else if ( dv_cls == USB_DEV_CLASS_HUB ) {  // HUB豸,
		DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = USB_DEV_CLASS_HUB;
		printf( "This program don't support Level 2 HUB\n");  // Ҫֶ֧༶HUBοչ
		s = HubClearPortFeature( i, HUB_PORT_ENABLE );  // ֹHUB˿
		if ( s != ERR_SUCCESS ) return( s );
		s = ERR_USB_UNSUPPORT;
	}
	else {   // Խһ
		s = CtrlSetUsbConfig( cfg );  // USB豸
		if ( s == ERR_SUCCESS ) {
//			豣˵ϢԱUSB
			DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_SUCCESS;
			DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType = dv_cls ? dv_cls : if_cls;
			SetUsbSpeed( 1 );  // ĬΪȫ
			return( ERR_SUCCESS );  /* δ֪豸ʼɹ */
		}
	}
	printf( "InitDevOnHub Err = %02X\n", (UINT16)s );
	DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus = ROOT_DEV_FAILED;
	SetUsbSpeed( 1 );  // ĬΪȫ
	return( s );
}

UINT8	EnumHubPort( UINT8 RootHubIndex )  // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼ʼUSB豸
{
	UINT8	i, s;
	printf( "EnumHubPort\n" );
	for ( i = 1; i <= RootHubDev[RootHubIndex].GpVar; i ++ ) {  // ѯĶ˿Ƿб仯
		SelectHubPort( RootHubIndex, 0 );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
		s = HubGetPortStatus( i );  // ȡ˿״̬
		if ( s != ERR_SUCCESS ) return( s );  // ǸHUBϿ
		if ( ( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) && ( TxBuffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) ) ) {  // 豸
			DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_CONNECTED;  // 豸
			DevOnHubPort[RootHubIndex][i-1].DeviceAddress = 0x00;
			s = HubGetPortStatus( i );  // ȡ˿״̬
			if ( s != ERR_SUCCESS ) return( s );  // ǸHUBϿ
			DevOnHubPort[RootHubIndex][i-1].DeviceSpeed = TxBuffer[1] & (1<<(HUB_PORT_LOW_SPEED&0x07)) ? 0 : 1;  // ٻȫ
			if ( DevOnHubPort[RootHubIndex][i-1].DeviceSpeed ) printf( "Found full speed device on port %1d\n", (UINT16)i );
			else printf( "Found low speed device on port %1d\n", (UINT16)i );
			mDelaymS( 200 );  // ȴ豸ϵȶ	
			s = HubSetPortFeature( i, HUB_PORT_RESET );  // 豸ӵĶ˿ڸλ
			if ( s != ERR_SUCCESS ) return( s );  // ǸHUBϿ
			printf( "Reset port and then wait in\n" );
			do {  // ѯλ˿,ֱλ,ɺ״̬ʾ
				mDelaymS( 1 );
				s = HubGetPortStatus( i );
				if ( s != ERR_SUCCESS ) return( s );  // ǸHUBϿ
			} while ( TxBuffer[0] & (1<<(HUB_PORT_RESET&0x07)) );  // ˿ڸλȴ
			mDelaymS( 100 );
//			s = HubClearPortFeature( i, C_PORT_RESET ); // λɱ־
//			s = HubSetPortFeature( i, HUB_PORT_ENABLE );  // HUB˿
			s = HubClearPortFeature( i, HUB_C_PORT_CONNECTION ); // ӻƳ仯־
			if ( s != ERR_SUCCESS ) return( s );
			s = HubGetPortStatus( i );  // ٶȡ״̬,豸Ƿ
			if ( s != ERR_SUCCESS ) return( s );
			if ( ( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 ) DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;  // 豸
			s = InitDevOnHub( RootHubIndex, i );  // ʼUSB豸
			if ( s != ERR_SUCCESS ) return( s );
			SetUsbSpeed( 1 );  // ĬΪȫ
		}
		else if ( ( TxBuffer[0]&(1<<(HUB_PORT_CONNECTION&0x07)) ) == 0 ) {  // 豸ѾϿ
			if ( DevOnHubPort[RootHubIndex][i-1].DeviceStatus >= ROOT_DEV_CONNECTED ) printf( "Device on port %1d removed\n", (UINT16)i );
			DevOnHubPort[RootHubIndex][i-1].DeviceStatus = ROOT_DEV_DISCONNECT;  // 豸
			if ( TxBuffer[2]&(1<<(HUB_C_PORT_CONNECTION&0x07)) ) HubClearPortFeature( i, HUB_C_PORT_CONNECTION ); // Ƴ仯־
		}
	}
	return( ERR_SUCCESS );  // زɹ
}

UINT8	EnumAllHubPort( void )  // öROOT-HUB˿ⲿHUBĶUSB豸
{
	UINT8	s, RootHubIndex;
	printf( "EnumAllHubPort\n" );
	for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ ) {
		if ( RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS && RootHubDev[RootHubIndex].DeviceType == USB_DEV_CLASS_HUB ) {  // HUBöٳɹ
			SelectHubPort( RootHubIndex, 0 );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
//			ʲô?  HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
			s = EnumHubPort( RootHubIndex );  // öָROOT-HUB˿ϵⲿHUBĸ˿,˿ӻƳ¼
			if ( s != ERR_SUCCESS ) {  // HUBϿ
				printf( "EnumAllHubPort err = %02X\n", (UINT16)s );
			}
			SetUsbSpeed( 1 );  // ĬΪȫ
		}
	}
	return( ERR_SUCCESS );
}

UINT16	SearchTypeDevice( UINT8 type )  // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں,˿ںΪ0xFFFFδ
{// 8λΪROOT-HUB˿ں,8λΪⲿHUBĶ˿ں,8λΪ0豸ֱROOT-HUB˿
// ȻҲԸUSBĳVIDƷPID(Ҫ¼豸VIDPID),Լָ
	UINT8	RootHubIndex, HubPortIndex;
	for ( RootHubIndex = 0; RootHubIndex != 2; RootHubIndex ++ ) {  // ʱԱ豸;γĳЩϢδʱµ
		if ( RootHubDev[RootHubIndex].DeviceType == type && RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS ) return( (UINT16)RootHubIndex << 8 );  // ƥöٳɹ,ROOT-HUB˿
		if ( RootHubDev[RootHubIndex].DeviceType == USB_DEV_CLASS_HUB && RootHubDev[RootHubIndex].DeviceStatus >= ROOT_DEV_SUCCESS ) {  // ⲿHUBöٳɹ
			for ( HubPortIndex = 1; HubPortIndex <= RootHubDev[RootHubIndex].GpVar; HubPortIndex ++ ) {  // ⲿHUBĸ˿
				if ( DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceType == type && DevOnHubPort[RootHubIndex][HubPortIndex-1].DeviceStatus >= ROOT_DEV_SUCCESS )
					return( ( (UINT16)RootHubIndex << 8 ) | HubPortIndex );  // ƥöٳɹ
			}
		}
	}
	return( 0xFFFF );
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( void )
{
//	SCON = 0x50;
	SM0 = 0;
	SM1 = 1;
	SM2 = 0;
	REN = 1;
	PCON |= SMOD;
	TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;  // 0X20
	T2MOD = T2MOD & ~(bTMR_CLK | bT1_CLK);  // *12
	TH1 = 0-13;//0xF3;  /* 12MHz, 4800bps*12=57600bps */
	TR1 = 1;
	TI = 1;
}

void	InitUSB_Host( void )  // ʼUSB
{
	UINT8	i;
	IE_USB = 0;
//	LED_CFG = 1;
//	LED_RUN = 0;
	USB_CTRL = bUC_HOST_MODE;  // 趨ģʽ
	USB_DEV_AD = 0x00;
	UH_EP_MOD = bUH_EP_TX_EN | bUH_EP_RX_EN ;
	UH_RX_DMA = RxBuffer;
	UH_TX_DMA = TxBuffer;
	UH_RX_CTRL = 0x00;
	UH_TX_CTRL = 0x00;
	USB_CTRL = bUC_HOST_MODE | bUC_INT_BUSY | bUC_DMA_EN;  // USBDMA,жϱ־δǰԶͣ
//	UHUB0_CTRL = 0x00;
//	UHUB1_CTRL = 0x00;
	UH_SETUP = bUH_SOF_EN;
	USB_INT_FG = 0xFF;  // жϱ־
	for ( i = 0; i != 2; i ++ ) DisableRootHubPort( i );  // 
	USB_INT_EN = bUIE_TRANSFER | bUIE_DETECT;
//	IE_USB = 1;  // ѯʽ
}


UINT8 SETorOFFNumLock(PUINT8 buf)//NumLockĵж
{
    UINT8 tmp[]={0x21,0x09,0x00,0x02,0x00,0x00,0x01,0x00};
    UINT8 len,s;
    if((buf[2]==0x53)&(buf[0]|buf[1]|buf[3]|buf[4]|buf[5]|buf[6]|buf[7]==0))
    {
	    for ( s = 0; s != sizeof( tmp ); s ++ ) {
		   ((PUINT8X)pSetupReq)[ s ] = tmp[s];
	    }
        s = HostCtrlTransfer( TxBuffer, &len );  // ִпƴ
	      if ( s != ERR_SUCCESS ) return( s );    
    }
	return( ERR_SUCCESS );
}

void USBKeyToASCII( )
{
 UINT8 Tmp;
//  printf( "RxBuffer %02x\n",(UINT16)RxBuffer[2] );
 if((RxBuffer[2] == 0)&&(RxBuffer[3] == 0)) return;//ͷŰ
 if((RxBuffer[0] == 0x20)&&(RxBuffer[2] == 0x26)) {printf("(");return;}
 if((RxBuffer[0] == 0x20)&&(RxBuffer[2] == 0x27)) {printf(")");return;}
 if(RxBuffer[2] == 0x27) {printf("0");return;}	
 if((RxBuffer[2] >= 0x1E)&&(RxBuffer[2] <= 0x26))
 {
   Tmp = RxBuffer[2]-0x1E+'1';
   printf("%c",Tmp);return;
 }	 
}
main( ) {
	UINT8	i, s, len, endp;
	UINT16	loc;
    SAFE_MOD = 0x55;                                                   //ȫģʽ
    SAFE_MOD = 0xAA;
	  CLOCK_CFG &= ~MASK_SYS_CK_DIV;
    CLOCK_CFG |= 12;                                                    //ϵͳʱ 
    SAFE_MOD = 0xFF;                                                   //رհȫģʽ
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start @ChipID=%02X\n", (UINT16)CHIP_ID );
	InitUSB_Host( );
	FoundNewDev = 0;
	printf( "Wait Device In\n" );
	while ( 1 ) {
// 		for(i=0x1e;i<=0x27;i++)
//     {
//       RxBuffer[2] = i;			
//       USBKeyToASCII( );			
//       mDelaymS(100);			
//     }
		s = ERR_SUCCESS;
		if ( UIF_DETECT ) {  // USBж
			UIF_DETECT = 0;  // жϱ־
			s = AnalyzeRootHub( );   // ROOT-HUB״̬
			if ( s == ERR_USB_CONNECT ) FoundNewDev = 1;
		}

		if ( FoundNewDev || s == ERR_USB_CONNECT ) {  // µUSB豸
			FoundNewDev = 0;
			mDelaymS( 200 );  // USB豸ղδȶ,ʵȴUSB豸ٺ,ζ
			s = EnumAllRootDevice( );  // öROOT-HUB˿ڵUSB豸
			if ( s != ERR_SUCCESS ) printf( "EnumAllRootDev err = %02X\n", (UINT16)s );
		}
//		other work for each device
// 		mDelaymS( 100 );  // ģⵥƬ
    // öʱģ,Ҫ
				loc = SearchTypeDevice( DEV_TYPE_KEYBOARD );  // ROOT-HUBԼⲿHUB˿ָ͵豸ڵĶ˿ں
				if ( loc != 0xFFFF ) {  // ҵ,KeyBoardδ?
// 					printf( "Query Keyboard @%04X\n", loc );
					i = (UINT8)( loc >> 8 );
					len = (UINT8)loc;
					SelectHubPort( i, len );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
					endp = len ? DevOnHubPort[i][len-1].GpVar : RootHubDev[i].GpVar;  // ж϶˵ĵַ,λ7ͬ־λ
// 										printf("%02X  ",endp);
					if ( endp & USB_ENDP_ADDR_MASK ) {  // ˵Ч
						s = USBHostTransact( USB_PID_IN << 4 | endp & 0x7F, endp & 0x80 ? bUH_R_TOG | bUH_T_TOG : 0, 0 );  // CH559,ȡ,NAK
						if ( s == ERR_SUCCESS ) {
							endp ^= 0x80;  // ͬ־ת
							if ( len ) DevOnHubPort[i][len-1].GpVar = endp;  // ͬ־λ
							else RootHubDev[i].GpVar = endp;
							len = USB_RX_LEN;  // յݳ
							if ( len ) {
								  USBKeyToASCII( );
// 								SETorOFFNumLock(RxBuffer);
// 								printf("keyboard data: ");
// 								for ( i = 0; i < len; i ++ ) printf("x%02X ",(UINT16)(RxBuffer[i]) );
// 								printf("\n");
							}
						}
// 						else if ( s != ( USB_PID_NAK | ERR_USB_TRANSFER ) ) printf("keyboard error %02x\n",(UINT16)s);  // ǶϿ
					}
// 					else printf("keyboard no interrupt endpoint\n");
					SetUsbSpeed( 1 );  // ĬΪȫ
				}
	}
}
